<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>m17n ライブラリ: 入力メソッド (GUI)</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- 作成： Doxygen 1.6.3 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'検索');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>メインページ</span></a></li>
      <li><a href="pages.html"><span>関連ページ</span></a></li>
      <li><a href="modules.html"><span>モジュール</span></a></li>
      <li><a href="annotated.html"><span>データ構造</span></a></li>
      <li><a href="files.html"><span>ファイル</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="検索" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>入力メソッド (GUI)<br/>
<small>
[<a class="el" href="group__m17nGUI.html">GUI API</a>]</small>
</h1>
<p>ウィンドウシステム上の入力メソッドのサポート.  
<a href="#_details">[詳細]</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>データ構造</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputGUIArgIC.html">MInputGUIArgIC</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">関数 <a class="el" href="group__m17nInputMethod.html#ga8b32df84c645f73ed65e20a1d51c1859" title="入力コンテクストを生成する.">minput_create_ic()</a> の引数の型宣言.  <a href="structMInputGUIArgIC.html#_details">[詳細]</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputXIMArgIM.html">MInputXIMArgIM</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">関数 <a class="el" href="group__m17nInputMethod.html#ga34d3e527bfd705d2b7f2b749199c1e11" title="入力メソッドをオープンする.">minput_open_im()</a> の引数 <b>arg</b> によって指される構造体.  <a href="structMInputXIMArgIM.html#_details">[詳細]</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputXIMArgIC.html">MInputXIMArgIC</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">関数 <a class="el" href="group__m17nInputMethod.html#ga8b32df84c645f73ed65e20a1d51c1859" title="入力コンテクストを生成する.">minput_create_ic()</a> の引数 <b>arg</b> によって指される構造体.  <a href="structMInputXIMArgIC.html#_details">[詳細]</a><br/></td></tr>
<tr><td colspan="2"><h2>関数</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethodWin.html#ga58715c630a04fd33f12394e9c93f1bad">minput_event_to_key</a> (<a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *frame, void *event)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">イベントを入力キーに変換する.  <a href="#ga58715c630a04fd33f12394e9c93f1bad"></a><br/></td></tr>
<tr><td colspan="2"><h2>変数</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structMInputDriver.html">MInputDriver</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethodWin.html#ga382ffd93fbaaa7226dd36af4a3fd7100">minput_gui_driver</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">ウィンドウシステムの内部入力メソッド用入力ドライバ.  <a href="#ga382ffd93fbaaa7226dd36af4a3fd7100"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethodWin.html#ga4e8d34da33638639ecc7386914def510">Mxim</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">"xim"を名前として持つシンボル .  <a href="#ga4e8d34da33638639ecc7386914def510"></a><br/></td></tr>
</table>
<hr/><a name="_details"></a><h2>説明</h2>
<p>ウィンドウシステム上の入力メソッドのサポート. </p>
<p>入力ドライバ <code>minput_gui_driver</code> は、 ウィンドウシステム上で用いられる内部入力メソッド用のドライバである。 このドライバは入力スポットに preedit テキストと status テキストを表示する。詳細については <code>minput_gui_driver</code> の説明を参照のこと。</p>
<p>m17n-X ライブラリは、<code>Mxim</code> と言う名前を持つ外部入力メソッドを提供している。これは XIM (X Input Method) をバックグラウンドの入力エンジンとして利用する。シンボル <code>Mxim</code> は <code>Minput_driver</code> というプロパティを持っており、その値は入力ドライバ <code>minput_xim_driver</code> へのポインタである。 詳細については <code>minput_xim_driver</code> の説明を参照のこと。 </p>
<hr/><h2>関数</h2>
<a class="anchor" id="ga58715c630a04fd33f12394e9c93f1bad"></a><!-- doxytag: member="input&#45;gui.c::minput_event_to_key" ref="ga58715c630a04fd33f12394e9c93f1bad" args="(MFrame *frame, void *event)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> minput_event_to_key </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *&nbsp;</td>
          <td class="paramname"> <em>frame</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>event</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>イベントを入力キーに変換する. </p>
<p>関数 <a class="el" href="group__m17nInputMethodWin.html#ga58715c630a04fd33f12394e9c93f1bad" title="イベントを入力キーに変換する.">minput_event_to_key()</a> は、<b>frame</b> のイベント <b>event</b> に対応する入力キーを返す。ここでの「対応」はウィンドウシステムに依存する。</p>
<p>m17n-X ライブラリの場合には、<b>event</b> は 構造体 <code>XKeyEvent</code> へのポインタであり、次のように処理される。</p>
<p>まず、関数 <code>XKeysymToString</code> によって、<b>event</b> の keysym 名を取得し、次いで以下の変更を加える。</p>
<p>名前が "a" .. "z" のいずれかであって <b>event</b> に Shift モディファイアがあれば、名前はそれぞれ "A" .. "Z" に変換され、Shift モディファイアは取り除かれる。</p>
<p>名前が１バイト長で <b>event</b> に Control モディファイアがあれば、名前と 0x1F とをビット単位で and 演算し、Control モディファイアは取り除かれる。</p>
<p>それでも <b>event</b> にまだモディファイアがあれば、名前の前にそれぞれ "S-" (Shift), "C-" (Control), "M-" (Meta), "A-" (Alt), , "G-" (AltGr), "s-" (Super), "H-" (Hyper)がこの順番で付く。</p>
<p>たとえば、keysym 名が "a" でイベントが Shift, Meta, and Hyper モディファイアを持てば、得られる名前は "M-H-A" である。</p>
<p>最後にその名前を持つシンボルを返す。 </p>

</div>
</div>
<hr/><h2>変数</h2>
<a class="anchor" id="ga382ffd93fbaaa7226dd36af4a3fd7100"></a><!-- doxytag: member="input&#45;gui.c::minput_gui_driver" ref="ga382ffd93fbaaa7226dd36af4a3fd7100" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structMInputDriver.html">MInputDriver</a> <a class="el" href="group__m17nInputMethodWin.html#ga382ffd93fbaaa7226dd36af4a3fd7100">minput_gui_driver</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>ウィンドウシステムの内部入力メソッド用入力ドライバ. </p>
<p>入力ドライバ <code>minput_gui_driver</code> は、ウィンドウシステム上で用いられる入力メソッド用ドライバである。</p>
<p>このドライバは、関数 <a class="el" href="group__m17nInputMethod.html#gac12030bd2d5c265a7327a9487f9c1376" title="入力コンテクストのスポットを設定する.">minput_set_spot()</a> によって設定された入力スポットに preedit テキスト用のサブウィンドウと status テキスト用のサブウィンドウを作り、それぞれを表示する。</p>
<p>マクロ <a class="el" href="group__m17nIntro.html#ga66879b35a1fee08b3e5966f6650c39f9" title="m17n ライブラリを初期化する.">M17N_INIT()</a> は変数 <code>minput_driver</code> をこのドライバへのポインタに設定し、全ての内部入力メソッドがこのドライバを使うようにする。</p>
<p>したがって、<code>minput_driver</code> がデフォルト値のままであれば、minput_ で始まる名前を持つ関数の引数のうちドライバ依存のものは以下のようになる。</p>
<p>関数 <a class="el" href="group__m17nInputMethod.html#ga34d3e527bfd705d2b7f2b749199c1e11" title="入力メソッドをオープンする.">minput_open_im()</a> の引数 <b>arg</b> は無視される。</p>
<p>関数 <a class="el" href="group__m17nInputMethod.html#ga8b32df84c645f73ed65e20a1d51c1859" title="入力コンテクストを生成する.">minput_create_ic()</a> の引数 <b>arg</b> は構造体 <code><a class="el" href="structMInputGUIArgIC.html" title="関数 minput_create_ic() の引数の型宣言.">MInputGUIArgIC</a></code> へのポインタでなくてはならない。詳細については <code><a class="el" href="structMInputGUIArgIC.html" title="関数 minput_create_ic() の引数の型宣言.">MInputGUIArgIC</a></code> の説明を参照のこと。</p>
<p>関数 <a class="el" href="group__m17nInputMethod.html#ga6d9c3c97524114496fd8b7f70af92457" title="入力キーをフィルタする.">minput_filter()</a> の引数 <b>arg</b> が <code>Mnil</code> の場合、 <b>arg</b> は <code>XEvent</code> 型のオブジェクトへのポインタでなくてはならない。この場合 <b>key</b> は <b>arg</b> から生成される。</p>
<p>関数 <a class="el" href="group__m17nInputMethod.html#gafe533480c705b877189938a0eecb1b57" title="入力コンテクスト中のテキストを探す.">minput_lookup()</a> の引数 <b>arg</b> は関数 <a class="el" href="group__m17nInputMethod.html#ga6d9c3c97524114496fd8b7f70af92457" title="入力キーをフィルタする.">minput_filter()</a> の引数 <b>arg</b> と同じでなくてはならない。 </p>

</div>
</div>
<a class="anchor" id="ga4e8d34da33638639ecc7386914def510"></a><!-- doxytag: member="input&#45;gui.c::Mxim" ref="ga4e8d34da33638639ecc7386914def510" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nInputMethodWin.html#ga4e8d34da33638639ecc7386914def510">Mxim</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>"xim"を名前として持つシンボル . </p>
<p>変数 Mxim は"xim"を名前として持つシンボルである。"xim" は入力メソッドドライバ <a class="el" href="m17n-X_8h.html#aa416d384957c7e4f69349d62f74e1a19">minput_xim_driver</a> の名前である。 </p>

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>全て</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>データ構造</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>ファイル</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>関数</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>変数</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&nbsp;</span>型定義</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&nbsp;</span>列挙型</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&nbsp;</span>列挙型の値</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&nbsp;</span>マクロ定義</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<!-- -*- coding: utf-8; -*- -->
<hr>

<ADDRESS>
<a href="http://www.m17n.org/m17n-lib-ja/index.html" target="mulewindow"><img src="parrot.png" align=bottom alt="m17n-lib Home" border=0></a>
</ADDRESS>
</body>
</HTML>

<!-- Copyright information

Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)

This file is part of the m17n library documentation.

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts,
and no Back-Cover Texts.  A copy of the license is included in the
appendix entitled "GNU Free Documentation License".
-->
